/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-bwi-planning-0.2.1-0raring-20150809-1026/srv/CostLearnerInterface.srv
 *
 */


#ifndef BWI_PLANNING_MESSAGE_COSTLEARNERINTERFACEREQUEST_H
#define BWI_PLANNING_MESSAGE_COSTLEARNERINTERFACEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace bwi_planning
{
template <class ContainerAllocator>
struct CostLearnerInterfaceRequest_
{
  typedef CostLearnerInterfaceRequest_<ContainerAllocator> Type;

  CostLearnerInterfaceRequest_()
    : location()
    , door_from()
    , door_to()
    , cost(0.0)  {
    }
  CostLearnerInterfaceRequest_(const ContainerAllocator& _alloc)
    : location(_alloc)
    , door_from(_alloc)
    , door_to(_alloc)
    , cost(0.0)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _location_type;
  _location_type location;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _door_from_type;
  _door_from_type door_from;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _door_to_type;
  _door_to_type door_to;

   typedef float _cost_type;
  _cost_type cost;




  typedef boost::shared_ptr< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CostLearnerInterfaceRequest_

typedef ::bwi_planning::CostLearnerInterfaceRequest_<std::allocator<void> > CostLearnerInterfaceRequest;

typedef boost::shared_ptr< ::bwi_planning::CostLearnerInterfaceRequest > CostLearnerInterfaceRequestPtr;
typedef boost::shared_ptr< ::bwi_planning::CostLearnerInterfaceRequest const> CostLearnerInterfaceRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace bwi_planning

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "627a1a3de8dd9f91e561a53c602eba1d";
  }

  static const char* value(const ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x627a1a3de8dd9f91ULL;
  static const uint64_t static_value2 = 0xe561a53c602eba1dULL;
};

template<class ContainerAllocator>
struct DataType< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bwi_planning/CostLearnerInterfaceRequest";
  }

  static const char* value(const ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
string location\n\
string door_from\n\
string door_to\n\
float32 cost\n\
";
  }

  static const char* value(const ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.location);
      stream.next(m.door_from);
      stream.next(m.door_to);
      stream.next(m.cost);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CostLearnerInterfaceRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::bwi_planning::CostLearnerInterfaceRequest_<ContainerAllocator>& v)
  {
    s << indent << "location: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.location);
    s << indent << "door_from: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.door_from);
    s << indent << "door_to: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.door_to);
    s << indent << "cost: ";
    Printer<float>::stream(s, indent + "  ", v.cost);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BWI_PLANNING_MESSAGE_COSTLEARNERINTERFACEREQUEST_H
